




; ------------------= Help Subroutine =--------------------
; display command help information
; ---------------------------------------------------------
; the help string to print follows:
;
help_str:
	dc.b "md <addr> <addr>           : display memory between <addr1> and <addr2>",13,10
	dc.b "rv                         : display contents of registers after SWI",13,10
	dc.b "rm <reg>                   : modify contents of <reg> where reg=<cbaxyp>",13,10
	dc.b "load                       : download S19 to RAM",13,10
	dc.b "mm <addr> <val>            : modify memory location <addr> with value <val>",13,10
	dc.b "fill <addr1> <addr2> <val> : fill between <addr1> and <addr2> with <val>",13,10
	dc.b "go <addr>                  : begin executing user code at <addr> (jmp)",13,10
	dc.b "res                        : resume execution after SWI",13,10
	dc.b "break [+][-][<addr>]       : add/remove/view breakpoints",13,10
	dc.b "dasm <addr> <ops>          : disassemble <ops> instructions starting at <addr>",13,10
	dc.b "step <addr>                : begin execution at <addr> line by line",13,10
	dc.b "sample                     : sample added command",13,10
	dc.b "help                       : display the help menu",13,10,0


***
;help_sub: "m_help.asm"
;	Called from the command line. "> help"
;	Takes no command line arguments.
;	Prints out a splash screen containing the possible command line arguments.
;	Reg Input: 
;		none
;	Reg Output:
;		none
***

help_sub:				 ; this is called when "help" is entered in the prompt
	ldy		#help_str	 ; loads a pointer to the string
	jsr		print_string	 ; prints the null-terminated string
					 ; see "serial.asm" for details on print_string


	ldy		#newline	 ; loads a pointer to the newline string
	jsr		print_string	 ; prints the null-terminated string
					 ; see "serial.asm" for details on print_string

	rts