


; ----------------= VIEW MEMORY SUBROUTINE =---------------
; displays in 16-byte lines the contents of memory
; between two addresses.
; ---------------------------------------------------------
***
;view_mem_sub: "m_view.asm"
;	Entered from the command line as "> md <addr1> <addr2>"
;	Takes the command line arguments;
;			<addr1> lower address to look from
;			<addr2> upper address to look to
;	It displays the memory contents from the first address rounded down to
;	The second address rounded up. There is no default case.
;	Reg Input:
;		None
;	Reg Output:
;		None
***

view_mem_sub:
	jsr		parse_address		; returns low address in X
	cmpb		#$ff			; error?
	beq		vms_error		; if there was an error, print it and leave
	stx		tempw			; store it for later	

	jsr		parse_address		; returns high addr in X
	cmpb		#$ff			; error?
	beq		vms_error		; if there was an error, print it and leave
	ldy		tempw			; Y is now the low addr
	
						; at this point, the low address is in tempw
						; the low address is in Y
						; and the high address is in X

*						* he really does not need to store the low address
*						* in tempw again, he just loaded y from tempw

	sty		tempw			; put it into a temp var to compare it to X
	cpx		tempw			; compare X (high addr) to tempw (low addr)
	ble		vms_done		; if high addr < low addr then its an error!

	stx		tempw			; put X (high addr) in var for later

*						* he puts y into x here, can be done better
*						* this entire section is really weird. I think it
* 						* can be done in a MUCH better way.

	pshy
	pulx					; X is now the low addr

	pshx					; yes, I realize this is dumb but I have to do it

	ldx		tempw			; get high address
	puld					; D is low addr
		
						; so now, D is the low address
						; and X is the high address.
				

	;jsr		print_address		; DEBUG

						; round down the lower address
	andb		#%11110000		; by making the lower nibble 0
	xgdx					; X <-> D
						; round up the upper address (in D right now)

	pshd					; stores the upper address on the stack
						; lower address is in X

*						* this part seems AWFUL. try to improve
*						*  REALLY need to take this horrid part out

	andb		#%00001111		; kills upper nibble of B
	ldaa		#$0f			; makes A into $0f
	sba					; subtracts the two, puts remainder in A
	adda 		#1			; adds one to A 

	psha					; such a damn hack
	pulb					; puts A into B

	clra					; clears A
	std		tempw2			; stores D
	puld					; gets back the old D address
	addd		tempw2			; adds the difference to D, rounding it up

	std		tempw			; store D -- the upper address
						; X is still the lower address



*						* not sure why this is here
	;xgdx					; D is now the lower and X the upper



loop1:
	ldy		#newline		; loads new line string
	jsr		print_string		; prints new line string
	

	cpx		tempw			; if X is now equal to the high value,
	beq		vms_done		; exit out of the code.


	jsr		print_address		; print_address prints what is in the X address, which
						; will start off as the low address and then be incremented
						; see "serial.asm"
	ldaa		#':'			; loads a ':' character to be printed
	jsr		put_char		; prints the character. see "serial.asm"
	ldaa		#32			; loads a space to be printed
	jsr		put_char		; prints the space. see "serial.asm"

loop2:




	ldaa		0,x			; load the number at the location
	jsr		print_number		; prints the number in A. see "serial.asm"
	ldaa		#32			; loads a space character
	jsr		put_char		; prints the space

	pshx					; puts x onto d
	puld					;

	andb		#%00001111		; clips off the upper nibble of B
	cmpb		#$0F			; if B is now FF, needs to move to the next line
	beq		vms_newline		; so it prints a new line
	bra		vms_blah		; otherwise goes to the next number
vms_newline:
	inx					; increments x to the next number
	bra		loop1			; then goes to the next line
vms_blah:
	inx					; increments x to the next number
	bra		loop2			; goes to print the next number
vms_done:
	ldy		#newline		; loads new line string
	jsr		print_string		; prints string
	rts					; returns from routine
vms_error:
	ldy		#error_msg		; loads address of error message
	jsr		print_string		; prints error message
	rts					; returns from routine
