


;-----------------------------------------
; The first line of information tells how many bytes are in the command.
; The second line is the actual command stored in memory.
; The last line is the address of the subroutine that matches the command.
; See "parse.asm" for more information. parse_command_line is the subroutine
; that actually uses this little prompt command table. More menu commands
; can be entered as long as they follow this general format.
;-----------------------------------------





; ------ prompt command table ------

cmd_start	dc.b	2			
vm_cmd		dc.b	"md"				; memory display (formerly memory view)
		dc.w	view_mem_sub

		dc.b	2
		dc.b	"go"				; "go" or jmp to user code
		dc.w	go_addr_sub

		dc.b	4
		dc.b	"help"				; duh
		dc.w	help_sub

		dc.b	2
		dc.b	"mm"				; memory modify
		dc.w	edit_mem_sub

		dc.b	4	
		dc.b	"fill"				; block fill
		dc.w	block_fill_sub

		dc.b	4
		dc.b	"load"				; S19 download
		dc.w	download_sub

		dc.b	2
		dc.b	"rv"				; register view
		dc.w	reg_view_sub
	
		dc.b	2
		dc.b	"rm"				; register modify
		dc.w	reg_edit_sub

		dc.b	5
		dc.b	"break"				; breakpoint stuff
		dc.w	break_sub

		dc.b	3
		dc.b	"res"				; resume after SWI bkpt
		dc.w	resume_sub

		dc.b	4
		dc.b	"test"				; test code for the 4744 board?
		dc.w	test_sub

		dc.b	4
		dc.b	"dasm"
		dc.w	dis_assembly_sub		; disassembler

		dc.b	4
		dc.b	"step"				; subroutine to step through a program
		dc.w	step_sub			


		dc.b	6
		dc.b	"sample"			; sample command prompt added
		dc.w	sample_sub			


		dc.b	1
cmd_end		dc.b	"blank"				; this has to be here -- don't remove

